



%% DEFINITION OF SIGNAL TEST: 2 possible choices for signal %%%%%%%%%%%%%%%%%%%%%%
    % Stype = 1 : 'white noise AM'
    % Stype = 2 : 'sinus FM + pure white noise' 


% Nx = 1024 ;
Nx = 2048 ;
% T=Nx/20 ;    
 T=Nx/5.1;  
% T=Nx*30;
f1 = 1./T ;
Stype=2;

%for Stype=1 ;
    alpha=0.5 ;
    
%for  Stype=2 ;
    beta = 0.08 ;
    f0 = 0.25 ;
    SNR = 20 ; 

    
%% COMPUTATION of SIGNAL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if Stype == 1,          %% AM
    modulation = alpha ;
    x = randn(1,Nx).*(1+modulation*sin(2*pi*f1*(-Nx/2:(Nx-1)/2))) ; 
elseif Stype == 2,      %% FM
    modulation = beta ;
    x = real(fmsin(Nx,f0-modulation,f0+modulation,T)) ; 
    y = sigmerge(x,randn(size(x)),SNR) ; 
    x = y.' ;
elseif Stype == 3,      %% AM-FM of poster/presentations
    x = real(fmsin(Nx,0.1,0.4,Nx/3).*amgauss(Nx,Nx/2,Nx/2)) ;
    x = x.' ;
end;
x = x/std(x) ;
disp(['Stype = ' num2str(Stype) ' / T = ' num2str(T) ' / Nx = ' num2str(Nx) ' / Nperiod = ' num2str(Nx/T)]);


figure(1); clf;plot(x);
   

%% Statistics of the test

opttfr1.choixtfr='mtfr';
opttest1=[];
opttest1.JJ=50;
optfig1=0;


[theta1,theta0,gam_hat,gam_thresh,res_test,INS,INS_thresh,opttfr,opttest]=statio_test_funct(x,opttfr1,opttest1,optfig1) ;



%% Iteration over several window length for the TFR

vNh0 = [0.015 0.03 0.05 0.1 0.15 0.2 0.25 0.3 0.4 0.5] ; 
NvNh0 = length(vNh0);

optfig1=[];

for ii=1:NvNh0,
    opttfr1.Nh0=vNh0(ii);
    [theta1,theta0,gam_hat,gam_thresh,res_test,INS,INS_thresh,opttfr,opttest]=statio_test_funct(x,opttfr1,opttest1,optfig1) ;
    
STAT(ii).Nh=opttfr.Nh;
STAT(ii).theta1=theta1;
STAT(ii).theta0=theta0;
STAT(ii).gam_hat=gam_hat;
STAT(ii).gam_thresh=gam_thresh;
STAT(ii).res_test=res_test;
STAT(ii).INS=INS;
STAT(ii).INS_thresh=INS_thresh;
STAT(ii).gam_hat=gam_hat;

end;


%%
clear res_test_tot INS_tot INS_thresh_tot gam_hat_tot

for imc=1:NvNh0,
res_test_tot(imc)=STAT(imc).res_test;
INS_tot(imc)=STAT(imc).INS;
INS_thresh_tot(imc)=STAT(imc).INS_thresh;
gam_hat_tot(:,imc)=STAT(imc).gam_hat;
end;


%% Display the results

Nhist=opttest.Nhist;
JJ=opttest.JJ;
[hh,bb] = hist(theta0,Nhist) ;
hh_est = gampdf(bb,gam_hat(1),gam_hat(2)) ;
dbb = bb(2)-bb(1) ; 

figure(21); clf;
bar(bb,hh/(JJ)/dbb)
hold on
plot(bb,hh_est,'r','LineWidth',2);
lesaxes=axis;   
plot([theta1 theta1],[lesaxes(3) lesaxes(4)],'m','LineWidth',2);
plot([gam_thresh gam_thresh],[lesaxes(3) lesaxes(4)],'k--','LineWidth',2);
hold off; 
title(['Test Result = ' num2str(res_test) ' | INS = ' num2str(INS)]);

%% Results vs. Nh0

figure(32); clf;
plot(vNh0,INS_tot,'m+-','LineWidth',2);
hold on; grid on
plot(vNh0,INS_thresh_tot,'k--','LineWidth',2);
lesaxes=axis;
lesaxes(4)=max(lesaxes(4),4);
lesaxes(3)=min(lesaxes(3),0);
axis(lesaxes);
title(['\Theta_1 in magenta, threshold in black']);





