% imageTF.m
%
% P. Flandrin, Nov. 18, 2005
%
% displays a time-frequency distribution
%
% input - M : time-frequency matrix
%       - dyn : dynamic range (in dB)
%       - c : choice of colormap, 1 = colour (default), else = b&w
%       - b : colorbar, 1 = yes (default), else = no

function imageTF(M,dyn,c,b) ;

if (nargin == 2),
    c = 1 ;
    b = 1 ;
end
if (nargin == 3),
    b = 1 ;
end

% if ~exist('fs','var')
%     fs = 1;
% end

S = size(M);
M = M/max(max(M)) ;
M = max(M,10^(-dyn/10)) ;
imagesc([1,S(2)],[0,.5],(10*log10(M)),[-dyn 0])
set(gca,'YDir','normal')
%set(gca,'YTick',[]);set(gca,'XTick',[])
%title(['dynamic range = ',int2str(dyn),' dB'])
xlabel('time')
ylabel('frequency')
if c == 1
    colormap(jet)
else
    colormap(flipud(gray))
end
if b == 1
    colorbar
end
